﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Linq;

namespace Performance2
{
    public class BatchObservableCollection<T> : ObservableCollection<T>
    {
        public BatchObservableCollection() { }

        public BatchObservableCollection(List<T> members) : base(members) { }

        public virtual void BatchReplace(List<T> newItems)
        {
            var oldItems = Items.ToList();

            if ((newItems.Count == 0 && oldItems.Count == 0)) return;

            Items.Clear();

            foreach (var data in newItems)
                Items.Add(data);

            var args = new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Replace, newItems, oldItems);
            OnCollectionChanged(args);
        }
    }
}
